
        
import * as _lib from "./pkg_wasm/index.js";

const _qpToInternalCtx = (ctx) => {
    const sym = ctx.sym.toJSON();
    const bars = ctx.ohlcv.bars.map(r => r.toJSON());
    
    const internalSym = _lib.Sym.fromJSON(sym);
    const internalOhlcv = _lib.Ohlcv.fromBars(bars.map(r => _lib.OhlcvBar.fromJSON(r)));
    const internalCtx = new _lib.Ctx(internalOhlcv, internalSym);

    return internalCtx;
}

        
export function accdist(ctx, ) {
    return _lib.Incr_fn_accdist_da4b16.make(_qpToInternalCtx(ctx), ).collect()
  }

class AccdistLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Accdist {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_accdist_da4b16.make(this.ctx, );
    this.locals = AccdistLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next() {
    return this.inner.next()
  }
}
    

export function cum(ctx, src, ) {
    return _lib.Incr_fn_cum_0aa26d.make(_qpToInternalCtx(ctx), ).collect(src)
  }

class CumLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Cum {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_cum_0aa26d.make(this.ctx, );
    this.locals = CumLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src) {
    return this.inner.next(src)
  }
}
    

export function change(ctx, src, ) {
    return _lib.Incr_fn_change_2683fb.make(_qpToInternalCtx(ctx), ).collect(src)
  }

class ChangeLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Change {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_change_2683fb.make(this.ctx, );
    this.locals = ChangeLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src) {
    return this.inner.next(src)
  }
}
    

export function barssince(ctx, condition, ) {
    return _lib.Incr_fn_barssince_86a109.make(_qpToInternalCtx(ctx), ).collect(condition)
  }

class BarssinceLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Barssince {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_barssince_86a109.make(this.ctx, );
    this.locals = BarssinceLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(condition) {
    return this.inner.next(condition)
  }
}
    

export function roc(ctx, src, length, ) {
    return _lib.Incr_fn_roc_5ead0b.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class RocLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Roc {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_roc_5ead0b.make(this.ctx, );
    this.locals = RocLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function crossover(ctx, source1, source2, ) {
    return _lib.Incr_fn_crossover_e509b3.make(_qpToInternalCtx(ctx), ).collect(source1, source2)
  }

class CrossoverLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Crossover {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_crossover_e509b3.make(this.ctx, );
    this.locals = CrossoverLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(source1, source2) {
    return this.inner.next(source1, source2)
  }
}
    

export function crossunder(ctx, source1, source2, ) {
    return _lib.Incr_fn_crossunder_12e9cf.make(_qpToInternalCtx(ctx), ).collect(source1, source2)
  }

class CrossunderLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Crossunder {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_crossunder_12e9cf.make(this.ctx, );
    this.locals = CrossunderLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(source1, source2) {
    return this.inner.next(source1, source2)
  }
}
    

export function cross(ctx, source1, source2, ) {
    return _lib.Incr_fn_cross_78e5cb.make(_qpToInternalCtx(ctx), ).collect(source1, source2)
  }

class CrossLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Cross {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_cross_78e5cb.make(this.ctx, );
    this.locals = CrossLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(source1, source2) {
    return this.inner.next(source1, source2)
  }
}
    

export function highestbars(ctx, src, length, ) {
    return _lib.Incr_fn_highestbars_23b181.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class HighestbarsLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Highestbars {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_highestbars_23b181.make(this.ctx, );
    this.locals = HighestbarsLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function lowestbars(ctx, src, length, ) {
    return _lib.Incr_fn_lowestbars_f06605.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class LowestbarsLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Lowestbars {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_lowestbars_f06605.make(this.ctx, );
    this.locals = LowestbarsLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function highest(ctx, src, length, ) {
    return _lib.Incr_fn_highest_9edcdf.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class HighestLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Highest {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_highest_9edcdf.make(this.ctx, );
    this.locals = HighestLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function lowest(ctx, src, length, ) {
    return _lib.Incr_fn_lowest_e54ba1.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class LowestLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Lowest {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_lowest_e54ba1.make(this.ctx, );
    this.locals = LowestLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function swma(ctx, src, ) {
    return _lib.Incr_fn_swma_8ec157.make(_qpToInternalCtx(ctx), ).collect(src)
  }

class SwmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Swma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_swma_8ec157.make(this.ctx, );
    this.locals = SwmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src) {
    return this.inner.next(src)
  }
}
    

export function sma(ctx, src, length, ) {
    return _lib.Incr_fn_sma_c468bf.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class SmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Sma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_sma_c468bf.make(this.ctx, );
    this.locals = SmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function ema(ctx, src, length, ) {
    return _lib.Incr_fn_ema_eabcc4.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class EmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Ema {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_ema_eabcc4.make(this.ctx, );
    this.locals = EmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function rma(ctx, src, length, ) {
    return _lib.Incr_fn_rma_c4a61a.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class RmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Rma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_rma_c4a61a.make(this.ctx, );
    this.locals = RmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function wma(ctx, src, length, ) {
    return _lib.Incr_fn_wma_db949f.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class WmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Wma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_wma_db949f.make(this.ctx, );
    this.locals = WmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function lwma(ctx, src, length, ) {
    return _lib.Incr_fn_lwma_f682d8.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class LwmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Lwma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_lwma_f682d8.make(this.ctx, );
    this.locals = LwmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function hma(ctx, src, length, ) {
    return _lib.Incr_fn_hma_532aa0.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class HmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Hma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_hma_532aa0.make(this.ctx, );
    this.locals = HmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function vwma(ctx, src, length, ) {
    return _lib.Incr_fn_vwma_3a6971.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class VwmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Vwma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_vwma_3a6971.make(this.ctx, );
    this.locals = VwmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function dev(ctx, src, length, ) {
    return _lib.Incr_fn_dev_cac48b.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class DevLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Dev {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_dev_cac48b.make(this.ctx, );
    this.locals = DevLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function tr(ctx, handle_na, ) {
    return _lib.Incr_fn_tr_ba70e0.make(_qpToInternalCtx(ctx), ).collect(handle_na)
  }

class TrLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Tr {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_tr_ba70e0.make(this.ctx, );
    this.locals = TrLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(handle_na) {
    return this.inner.next(handle_na)
  }
}
    

export function atr(ctx, length, ) {
    return _lib.Incr_fn_atr_934fd4.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class AtrLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Atr {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_atr_934fd4.make(this.ctx, );
    this.locals = AtrLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function rsi(ctx, src, length, ) {
    return _lib.Incr_fn_rsi_250ed8.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class RsiLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Rsi {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_rsi_250ed8.make(this.ctx, );
    this.locals = RsiLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function cci(ctx, src, length, ) {
    return _lib.Incr_fn_cci_2b8ab4.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class CciLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Cci {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_cci_2b8ab4.make(this.ctx, );
    this.locals = CciLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function stdev(ctx, src, length, biased, ) {
    return _lib.Incr_fn_stdev_fab2d0.make(_qpToInternalCtx(ctx), ).collect(src, length, biased)
  }

class StdevLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Stdev {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_stdev_fab2d0.make(this.ctx, );
    this.locals = StdevLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length, biased) {
    return this.inner.next(src, length, biased)
  }
}
    

export function aroon(ctx, length, ) {
    return _lib.Incr_fn_aroon_141eba.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class AroonLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Aroon {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_aroon_141eba.make(this.ctx, );
    this.locals = AroonLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function supertrend(ctx, src, factor, atr_period, ) {
    return _lib.Incr_fn_supertrend_2c88cc.make(_qpToInternalCtx(ctx), ).collect(src, factor, atr_period)
  }

class SupertrendLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Supertrend {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_supertrend_2c88cc.make(this.ctx, );
    this.locals = SupertrendLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, factor, atr_period) {
    return this.inner.next(src, factor, atr_period)
  }
}
    

export function awesomeOscillator(ctx, src, slow_length, fast_length, ) {
    return _lib.Incr_fn_awesome_oscillator_9a7d5c.make(_qpToInternalCtx(ctx), ).collect(src, slow_length, fast_length)
  }

class AwesomeOscillatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class AwesomeOscillator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_awesome_oscillator_9a7d5c.make(this.ctx, );
    this.locals = AwesomeOscillatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, slow_length, fast_length) {
    return this.inner.next(src, slow_length, fast_length)
  }
}
    

export function balanceOfPower(ctx, ) {
    return _lib.Incr_fn_balance_of_power_4b4843.make(_qpToInternalCtx(ctx), ).collect()
  }

class BalanceOfPowerLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class BalanceOfPower {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_balance_of_power_4b4843.make(this.ctx, );
    this.locals = BalanceOfPowerLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next() {
    return this.inner.next()
  }
}
    

export function bollingerBandsPctB(ctx, src, length, mult, ) {
    return _lib.Incr_fn_bollinger_bands_pct_b_8b7a76.make(_qpToInternalCtx(ctx), ).collect(src, length, mult)
  }

class BollingerBandsPctBLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class BollingerBandsPctB {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_bollinger_bands_pct_b_8b7a76.make(this.ctx, );
    this.locals = BollingerBandsPctBLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length, mult) {
    return this.inner.next(src, length, mult)
  }
}
    

export function bollingerBandsWidth(ctx, src, length, mult, ) {
    return _lib.Incr_fn_bollinger_bands_width_ee0f57.make(_qpToInternalCtx(ctx), ).collect(src, length, mult)
  }

class BollingerBandsWidthLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class BollingerBandsWidth {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_bollinger_bands_width_ee0f57.make(this.ctx, );
    this.locals = BollingerBandsWidthLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length, mult) {
    return this.inner.next(src, length, mult)
  }
}
    

export function bollingerBands(ctx, src, length, mult, ) {
    return _lib.Incr_fn_bollinger_bands_730940.make(_qpToInternalCtx(ctx), ).collect(src, length, mult)
  }

class BollingerBandsLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class BollingerBands {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_bollinger_bands_730940.make(this.ctx, );
    this.locals = BollingerBandsLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length, mult) {
    return this.inner.next(src, length, mult)
  }
}
    

export function chaikinMoneyFlow(ctx, length, ) {
    return _lib.Incr_fn_chaikin_money_flow_93b85c.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class ChaikinMoneyFlowLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

    get cumVol() {
        return this.__inner._9165_cumVol()
  }
  
      
}

export class ChaikinMoneyFlow {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_chaikin_money_flow_93b85c.make(this.ctx, );
    this.locals = ChaikinMoneyFlowLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function chandeKrollStop(ctx, atr_length, atr_coeff, stop_length, ) {
    return _lib.Incr_fn_chande_kroll_stop_0fb980.make(_qpToInternalCtx(ctx), ).collect(atr_length, atr_coeff, stop_length)
  }

class ChandeKrollStopLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class ChandeKrollStop {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_chande_kroll_stop_0fb980.make(this.ctx, );
    this.locals = ChandeKrollStopLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(atr_length, atr_coeff, stop_length) {
    return this.inner.next(atr_length, atr_coeff, stop_length)
  }
}
    

export function choppinessIndex(ctx, length, ) {
    return _lib.Incr_fn_choppiness_index_7e8fa4.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class ChoppinessIndexLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class ChoppinessIndex {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_choppiness_index_7e8fa4.make(this.ctx, );
    this.locals = ChoppinessIndexLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function connorsRsi(ctx, src, rsi_length, up_down_length, roc_length, ) {
    return _lib.Incr_fn_connors_rsi_3ac79c.make(_qpToInternalCtx(ctx), ).collect(src, rsi_length, up_down_length, roc_length)
  }

class ConnorsRsiLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class ConnorsRsi {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_connors_rsi_3ac79c.make(this.ctx, );
    this.locals = ConnorsRsiLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, rsi_length, up_down_length, roc_length) {
    return this.inner.next(src, rsi_length, up_down_length, roc_length)
  }
}
    

export function coppockCurve(ctx, src, wma_length, long_roc_length, short_roc_length, ) {
    return _lib.Incr_fn_coppock_curve_b01959.make(_qpToInternalCtx(ctx), ).collect(src, wma_length, long_roc_length, short_roc_length)
  }

class CoppockCurveLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class CoppockCurve {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_coppock_curve_b01959.make(this.ctx, );
    this.locals = CoppockCurveLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, wma_length, long_roc_length, short_roc_length) {
    return this.inner.next(src, wma_length, long_roc_length, short_roc_length)
  }
}
    

export function donchianChannel(ctx, src, length, ) {
    return _lib.Incr_fn_donchian_channel_7679ae.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class DonchianChannelLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class DonchianChannel {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_donchian_channel_7679ae.make(this.ctx, );
    this.locals = DonchianChannelLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function macd(ctx, src, short_length, long_length, ) {
    return _lib.Incr_fn_macd_11ef9e.make(_qpToInternalCtx(ctx), ).collect(src, short_length, long_length)
  }

class MacdLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Macd {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_macd_11ef9e.make(this.ctx, );
    this.locals = MacdLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, short_length, long_length) {
    return this.inner.next(src, short_length, long_length)
  }
}
    

export function priceOscillator(ctx, src, short_length, long_length, ) {
    return _lib.Incr_fn_price_oscillator_4b8bf9.make(_qpToInternalCtx(ctx), ).collect(src, short_length, long_length)
  }

class PriceOscillatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class PriceOscillator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_price_oscillator_4b8bf9.make(this.ctx, );
    this.locals = PriceOscillatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, short_length, long_length) {
    return this.inner.next(src, short_length, long_length)
  }
}
    

export function relativeVigorIndex(ctx, length, ) {
    return _lib.Incr_fn_relative_vigor_index_c3c62c.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class RelativeVigorIndexLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class RelativeVigorIndex {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_relative_vigor_index_c3c62c.make(this.ctx, );
    this.locals = RelativeVigorIndexLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function relativeVolatilityIndex(ctx, src, length, ) {
    return _lib.Incr_fn_relative_volatility_index_289604.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class RelativeVolatilityIndexLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class RelativeVolatilityIndex {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_relative_volatility_index_289604.make(this.ctx, );
    this.locals = RelativeVolatilityIndexLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function stochasticRsi(ctx, src, stoch_length, rsi_length, k, d, ) {
    return _lib.Incr_fn_stochastic_rsi_824b6c.make(_qpToInternalCtx(ctx), ).collect(src, stoch_length, rsi_length, k, d)
  }

class StochasticRsiLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class StochasticRsi {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_stochastic_rsi_824b6c.make(this.ctx, );
    this.locals = StochasticRsiLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, stoch_length, rsi_length, k, d) {
    return this.inner.next(src, stoch_length, rsi_length, k, d)
  }
}
    

export function ultimateOscillator(ctx, fast_length, medium_length, slow_length, ) {
    return _lib.Incr_fn_ultimate_oscillator_12d069.make(_qpToInternalCtx(ctx), ).collect(fast_length, medium_length, slow_length)
  }

class UltimateOscillatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class UltimateOscillator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_ultimate_oscillator_12d069.make(this.ctx, );
    this.locals = UltimateOscillatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(fast_length, medium_length, slow_length) {
    return this.inner.next(fast_length, medium_length, slow_length)
  }
}
    

export function volumeOscillator(ctx, short_length, long_length, ) {
    return _lib.Incr_fn_volume_oscillator_249c65.make(_qpToInternalCtx(ctx), ).collect(short_length, long_length)
  }

class VolumeOscillatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class VolumeOscillator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_volume_oscillator_249c65.make(this.ctx, );
    this.locals = VolumeOscillatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(short_length, long_length) {
    return this.inner.next(short_length, long_length)
  }
}
    

export function vortexIndicator(ctx, length, ) {
    return _lib.Incr_fn_vortex_indicator_014043.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class VortexIndicatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class VortexIndicator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_vortex_indicator_014043.make(this.ctx, );
    this.locals = VortexIndicatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function williamsPctR(ctx, src, length, ) {
    return _lib.Incr_fn_williams_pct_r_8d8aee.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class WilliamsPctRLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class WilliamsPctR {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_williams_pct_r_8d8aee.make(this.ctx, );
    this.locals = WilliamsPctRLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function advanceDeclineRatio(ctx, length, ) {
    return _lib.Incr_fn_advance_decline_ratio_4920ed.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class AdvanceDeclineRatioLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class AdvanceDeclineRatio {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_advance_decline_ratio_4920ed.make(this.ctx, );
    this.locals = AdvanceDeclineRatioLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function detrendedPriceOscillator(ctx, length, centered, ) {
    return _lib.Incr_fn_detrended_price_oscillator_a2d0bd.make(_qpToInternalCtx(ctx), ).collect(length, centered)
  }

class DetrendedPriceOscillatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class DetrendedPriceOscillator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_detrended_price_oscillator_a2d0bd.make(this.ctx, );
    this.locals = DetrendedPriceOscillatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length, centered) {
    return this.inner.next(length, centered)
  }
}
    

export function bullBearPower(ctx, length, ) {
    return _lib.Incr_fn_bull_bear_power_3b0f5a.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class BullBearPowerLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class BullBearPower {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_bull_bear_power_3b0f5a.make(this.ctx, );
    this.locals = BullBearPowerLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function absolutePriceOscillator(ctx, src, fast_length, slow_length, ) {
    return _lib.Incr_fn_absolute_price_oscillator_74dd80.make(_qpToInternalCtx(ctx), ).collect(src, fast_length, slow_length)
  }

class AbsolutePriceOscillatorLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class AbsolutePriceOscillator {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_absolute_price_oscillator_74dd80.make(this.ctx, );
    this.locals = AbsolutePriceOscillatorLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, fast_length, slow_length) {
    return this.inner.next(src, fast_length, slow_length)
  }
}
    

export function knowSureThing(ctx, src, roc_length1, roc_length2, roc_length3, roc_length4, sma_length1, sma_length2, sma_length3, sma_length4, sig_length, ) {
    return _lib.Incr_fn_know_sure_thing_1817a6.make(_qpToInternalCtx(ctx), ).collect(src, roc_length1, roc_length2, roc_length3, roc_length4, sma_length1, sma_length2, sma_length3, sma_length4, sig_length)
  }

class KnowSureThingLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class KnowSureThing {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_know_sure_thing_1817a6.make(this.ctx, );
    this.locals = KnowSureThingLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, roc_length1, roc_length2, roc_length3, roc_length4, sma_length1, sma_length2, sma_length3, sma_length4, sig_length) {
    return this.inner.next(src, roc_length1, roc_length2, roc_length3, roc_length4, sma_length1, sma_length2, sma_length3, sma_length4, sig_length)
  }
}
    

export function momentum(ctx, src, length, ) {
    return _lib.Incr_fn_momentum_fe155f.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class MomentumLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Momentum {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_momentum_fe155f.make(this.ctx, );
    this.locals = MomentumLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function trix(ctx, src, length, ) {
    return _lib.Incr_fn_trix_bcad27.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class TrixLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Trix {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_trix_bcad27.make(this.ctx, );
    this.locals = TrixLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function trueStrengthIndex(ctx, src, long_length, short_length, ) {
    return _lib.Incr_fn_true_strength_index_59c9ff.make(_qpToInternalCtx(ctx), ).collect(src, long_length, short_length)
  }

class TrueStrengthIndexLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class TrueStrengthIndex {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_true_strength_index_59c9ff.make(this.ctx, );
    this.locals = TrueStrengthIndexLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, long_length, short_length) {
    return this.inner.next(src, long_length, short_length)
  }
}
    

export function dema(ctx, src, length, ) {
    return _lib.Incr_fn_dema_6fa53c.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class DemaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Dema {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_dema_6fa53c.make(this.ctx, );
    this.locals = DemaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function fwma(ctx, src, length, ) {
    return _lib.Incr_fn_fwma_b0c1e1.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class FwmaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Fwma {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_fwma_b0c1e1.make(this.ctx, );
    this.locals = FwmaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function moneyFlowIndex(ctx, src, length, ) {
    return _lib.Incr_fn_money_flow_index_eccf49.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class MoneyFlowIndexLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class MoneyFlowIndex {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_money_flow_index_eccf49.make(this.ctx, );
    this.locals = MoneyFlowIndexLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function easeOfMovement(ctx, length, divisor, ) {
    return _lib.Incr_fn_ease_of_movement_673394.make(_qpToInternalCtx(ctx), ).collect(length, divisor)
  }

class EaseOfMovementLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class EaseOfMovement {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_ease_of_movement_673394.make(this.ctx, );
    this.locals = EaseOfMovementLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length, divisor) {
    return this.inner.next(length, divisor)
  }
}
    

export function elderForceIndex(ctx, length, ) {
    return _lib.Incr_fn_elder_force_index_ce0163.make(_qpToInternalCtx(ctx), ).collect(length)
  }

class ElderForceIndexLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class ElderForceIndex {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_elder_force_index_ce0163.make(this.ctx, );
    this.locals = ElderForceIndexLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(length) {
    return this.inner.next(length)
  }
}
    

export function tema(ctx, src, length, ) {
    return _lib.Incr_fn_tema_c4b376.make(_qpToInternalCtx(ctx), ).collect(src, length)
  }

class TemaLocals {
    constructor(inner) {
        self.__inner = inner
    }

    

      
}

export class Tema {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_tema_c4b376.make(this.ctx, );
    this.locals = TemaLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next(src, length) {
    return this.inner.next(src, length)
  }
}
    

export function main(ctx, ) {
    return _lib.Incr_fn_main_a2110e.make(_qpToInternalCtx(ctx), ).collect()
  }

class MainLocals {
    constructor(inner) {
        self.__inner = inner
    }

    
}

export class Main {
  constructor(ctx, ) {
    this.ctx = _qpToInternalCtx(ctx);
    this.inner = _lib.Incr_fn_main_a2110e.make(this.ctx, );
    this.locals = MainLocals(this.inner)
  }

/* 
getCtx() {
    throw new Error("Not implemented yet");
  }
    */

  next() {
    return this.inner.next()
  }
}
    

       /* module.exports = {
            accdist,Accdist,cum,Cum,change,Change,barssince,Barssince,roc,Roc,crossover,Crossover,crossunder,Crossunder,cross,Cross,highestbars,Highestbars,lowestbars,Lowestbars,highest,Highest,lowest,Lowest,swma,Swma,sma,Sma,ema,Ema,rma,Rma,wma,Wma,lwma,Lwma,hma,Hma,vwma,Vwma,dev,Dev,tr,Tr,atr,Atr,rsi,Rsi,cci,Cci,stdev,Stdev,aroon,Aroon,supertrend,Supertrend,awesomeOscillator,AwesomeOscillator,balanceOfPower,BalanceOfPower,bollingerBandsPctB,BollingerBandsPctB,bollingerBandsWidth,BollingerBandsWidth,bollingerBands,BollingerBands,chaikinMoneyFlow,ChaikinMoneyFlow,chandeKrollStop,ChandeKrollStop,choppinessIndex,ChoppinessIndex,connorsRsi,ConnorsRsi,coppockCurve,CoppockCurve,donchianChannel,DonchianChannel,macd,Macd,priceOscillator,PriceOscillator,relativeVigorIndex,RelativeVigorIndex,relativeVolatilityIndex,RelativeVolatilityIndex,stochasticRsi,StochasticRsi,ultimateOscillator,UltimateOscillator,volumeOscillator,VolumeOscillator,vortexIndicator,VortexIndicator,williamsPctR,WilliamsPctR,advanceDeclineRatio,AdvanceDeclineRatio,detrendedPriceOscillator,DetrendedPriceOscillator,bullBearPower,BullBearPower,absolutePriceOscillator,AbsolutePriceOscillator,knowSureThing,KnowSureThing,momentum,Momentum,trix,Trix,trueStrengthIndex,TrueStrengthIndex,dema,Dema,fwma,Fwma,moneyFlowIndex,MoneyFlowIndex,easeOfMovement,EaseOfMovement,elderForceIndex,ElderForceIndex,tema,Tema,main,Main
        }*/
                